#ifndef __AI_LOAD_H__
#define __AI_LOAD_H__

/*************************************************************
*
*   FILE:             AI_LOAD.H
*
*   (C) Copyright 97 Artech Digital Entertainments.
*                    All rights reserved.
*
*   Monopoly Game AI Header.
*************************************************************/

/************************************************************/
/* DEFINES                                                  */
/************************************************************/

/*  The following are tags for each attribute we can set for the AI in 
    a text file. */
enum AI_ATTRIBUTESEnum
{
	AI_ATTRIBUTE_PLAYER_ATTITUDE = 0,
	AI_ATTRIBUTE_ATTITUDE_LOST_REJECT_TRADE,
	AI_ATTRIBUTE_ATTITUDE_CHANGE_TRADE_OBSERVING,
	AI_ATTRIBUTE_ATTITUDE_CHANGE_TICK,
	AI_ATTRIBUTE_ATTITUDE_NEUTRAL,
	AI_ATTRIBUTE_TIME_FORGET_TRADE,
	AI_ATTRIBUTE_MAX_TRADES,
	AI_ATTRIBUTE_TRADE_COUNTER_LIMIT,
	AI_ATTRIBUTE_TRADE_COUNTER_PROB,
	AI_ATTRIBUTE_MIN_CASH_ON_HAND,
	AI_ATTRIBUTE_CASH_STRATEGY,
	AI_ATTRIBUTE_HOUSING_STRAT,
	AI_ATTRIBUTE_BUYING_CASH_MULTIPLIER,
	AI_ATTRIBUTE_NO_MONO_STAGE_CASH_MULTIPLIER,
	AI_ATTRIBUTE_CASH_LIQUID_ASSETS_DEPENDANCE,
	AI_ATTRIBUTE_MONO_NOT_OWNED_CASH_MULTIPLIER,
	AI_ATTRIBUTE_MONO_STAGE_CASH_MULTIPLIER,
	AI_ATTRIBUTE_CHANCES_FACTOR,
	AI_ATTRIBUTE_CHANCES_THRESHOLD,
	AI_ATTRIBUTE_CASH_FACTOR,
	AI_ATTRIBUTE_PROPERTY_FACTORS,
	AI_ATTRIBUTE_CASH_COW_FACTORS,
	AI_ATTRIBUTE_TRADE_IMPORTANCE_FACTOR,
	AI_ATTRIBUTE_MIN_EVALUATION_THRESHOLD,
    AI_ATTRIBUTE_MIN_GIVE_MONOPOLY_EVALUATION,
	AI_ATTRIBUTE_MONOPOLY_RECEIVED_IMPORTANCE,
    AI_ATTRIBUTE_GIVING_MONOPOLY_IMPORTANCE,
	AI_ATTRIBUTE_BALTIC_RECEIVED_IMPORTANCE,
	AI_ATTRIBUTE_PROPERTY_ALLOW_TRADE_IMPORTANCE,
	AI_ATTRIBUTE_PROPERTY_ALLOW_MORE_TRADE_IMPORTANCE,
	AI_ATTRIBUTE_PROPERTY_ONE_UNOWNED_IMPORTANCE,
	AI_ATTRIBUTE_PROPERTY_TWO_UNOWNED_IMPORTANCE,
    AI_ATTRIBUTE_RAILROAD_IMPORTANCE,
    AI_ATTRIBUTE_UTILITY_IMPORTANCE,
    AI_ATTRIBUTE_MONOPOLY_VETO_IMPORTANCE,
    AI_ATTRIBUTE_NEG_PROP_IMPORTANCE_CHANGE_MULT,
	AI_ATTRIBUTE_PROPOSE_TRADE_PROBABILITY,
	AI_ATTRIBUTE_MONOPOLY_PROPOSE_TRADE_PROBABILITY,
    AI_ATTRIBUTE_PROPOSE_MONOPOLY_GIVE_AWAY_PROBABILITY,
    AI_ATTRIBUTE_MAX_HOUSES_PER_SQUARE_FOR_GIVE_AWAY,
	AI_ATTRIBUTE_MIN_ACTION_WAIT,
	AI_ATTRIBUTE_MAX_ACTION_WAIT,
	AI_ATTRIBUTE_WAIT_FOR_TRADE_CONSIDER,
	AI_ATTRIBUTE_PATIENCE,
    AI_ATTRIBUTE_NUMBER_TIMES_ALLOW_PROPERTY_TRADE,
    AI_ATTRIBUTE_TURNS_TO_FORGETTING_PROPERTY_TRADE,
    AI_ATTRIBUTE_MIN_EVALUATION_IF_FED_UP,
    AI_ATTRIBUTE_MONOPOLY_SUICIDE_FACTOR,
	AI_ATTRIBUTE_LOWEST_IMPORTANCE_FOR_COUNTER,
	AI_ATTRIBUTE_MINIMUM_NONMONOPOLY_TRADE_ATTITUDE,
	AI_ATTRIBUTE_WHAT_TO_TRADE_NEG_9,
	AI_ATTRIBUTE_WHAT_TO_TRADE_NEG_8,
	AI_ATTRIBUTE_WHAT_TO_TRADE_NEG_7,
	AI_ATTRIBUTE_WHAT_TO_TRADE_NEG_6,
	AI_ATTRIBUTE_WHAT_TO_TRADE_NEG_5,
	AI_ATTRIBUTE_WHAT_TO_TRADE_NEG_4,
	AI_ATTRIBUTE_WHAT_TO_TRADE_NEG_3,
	AI_ATTRIBUTE_WHAT_TO_TRADE_NEG_2,
	AI_ATTRIBUTE_WHAT_TO_TRADE_NEG_1,
	AI_ATTRIBUTE_WHAT_TO_TRADE_0,
	AI_ATTRIBUTE_WHAT_TO_TRADE_1,
	AI_ATTRIBUTE_WHAT_TO_TRADE_2,
	AI_ATTRIBUTE_WHAT_TO_TRADE_3,
	AI_ATTRIBUTE_WHAT_TO_TRADE_4,
	AI_ATTRIBUTE_WHAT_TO_TRADE_5,
	AI_ATTRIBUTE_WHAT_TO_TRADE_6,
	AI_ATTRIBUTE_WHAT_TO_TRADE_7,
	AI_ATTRIBUTE_WHAT_TO_TRADE_8,
	AI_ATTRIBUTE_WHAT_TO_TRADE_9,
	AI_ATTRIBUTE_WHAT_TO_TRADE_10,
	AI_TAG_STRATEGY_LEVEL_1,
	AI_TAG_STRATEGY_LEVEL_2,
	AI_TAG_STRATEGY_LEVEL_3,
	AI_TAG_GLOBAL_SETTINGS,

	AI_ATTRIBUTE_MAX,
	AI_ATTRIBUTE_NONE_FOUND

};
typedef int AI_ATTRIBUTE;

/*  The following are tags for config file for a drone game. */
enum AI_Drone_ConfigsEnum
{
    AI_DRONE_PLAYERS_TOKENS_PLAYING,
    AI_DRONE_CYCLE_PLAYERS,
    AI_DRONE_MAX_GAME_TIME,
    AI_DRONE_GAMES_TO_PLAY,

    AI_DRONE_MAX,
    AI_DRONE_NONE_FOUND
};
typedef int AI_Drone_Configs_Types;

#define AI_LOAD_MAX_VALUES		10   /* This number is the top number of values
									   a variable can have following it that we
									   will look at. Depends on RULE_MAX_PLAYERS
									   and entries in 
									   AI_Monopoly_Level_Trading_Generosity_Record  */
#define AI_TAB_CHAR				9	/* ASCII tab character. */
/************************************************************/
/* PROTOTYPES                                               */
/************************************************************/

extern BOOL AI_Load_AI(RULE_PlayerNumber player, int token, int level);
extern BOOL AI_Load_AI_File(wchar_t *name, RULE_PlayerNumber player, int level);
extern void AI_Initialize_Loading(void);
extern BOOL AI_Load_Drone_Mode_Configs(wchar_t *name);

/************************************************************/

#endif // __AI_LOAD_H__
